/************************************
 * This is the framework for those
 * who wish to write their own C
 * code for the basic badge
 * 
 * Modified by AI6XG November 2018
 * for Morse Code Practice
 * and CQ Hackaday!!
 ************************************/


#include "badge_user.h"


uint8_t wpm = 20;       //code speed in words per minute
uint8_t dit_length = 0; //dit and space length in mSec
uint8_t cw_pitch = 72;  //pitch 



void dit(void)
{
    sound_play_notes(cw_pitch,cw_pitch, cw_pitch,dit_length);
    char_space();                                               //add space after dit
}

void dah(void)
{
    sound_play_notes(cw_pitch,cw_pitch,cw_pitch,3 * dit_length);
    char_space();                                               //space after dah
}

void letter_space(void)
{
    wait_ms(2 * dit_length);            //letter space is 2 dits plus extra dit in dit() and dah() for 3 total
}

void char_space(void)
{
    wait_ms(dit_length);
}

void word_space(void)                   //word space is 6 dits plus extra dit in dit() and dah() for 7 total
{
    wait_ms(6 * dit_length);
}

void call_sign(void)                    //AI6XG
{
    dit();dah();letter_space();
    dit();dit();letter_space();
    dah();dit();dit();dit();dit();letter_space();
    dah();dit();dit();dah();letter_space();
    dah();dah();dit();letter_space();
}

void user_program_init(void)
	{
	/* This will run when User Program is first selected form the menu */
	clr_buffer();
	video_gotoxy(5,4);
    stdio_write("Use this example to write");
	video_gotoxy(5,5);
	stdio_write("your own C code for the badge.");
	}

void user_program_loop(void)
	{
	/* This should contain user program (will be run after init function)*/
	
	/* Write some stuff to the screen*/
    uint32_t m = 0;
    m = millis();
    
    srand(m);
	video_set_color(12,0);
	video_gotoxy(5,10);
    stdio_write("CQ Hackaday de AI6XG");

	video_gotoxy(2,14);
	stdio_write("Press shift_C to send CW");
    video_gotoxy(2,15);
    stdio_write( "Press shift_P for CW practice");
    video_gotoxy(2,16);
    stdio_write( "Press shift_S to stop practice");
    video_gotoxy(2,17);
    stdio_write( "Press any other key to stop CW");
    video_gotoxy(2,18);
    stdio_write("You pressed: ");
    
    
	
	while(1) //Loop forever
		{
		/* Example of a non-blocking delay */
		static uint32_t delay_until = 0;
		static uint8_t count = '0';
		if (millis()>=delay_until)
			{
				/* Writing directly to disp_buffer instead of stdio_write */
				/* Note that Y value is given before X: disp_buffer[Y][X]*/
//				disp_buffer[16][24] = count++;
				if (count > '9')
					{
						count = '0';
					}
				delay_until = millis()+1000;
			}

		/* React to user input */
		uint8_t get_stat, char_out;
		get_stat = stdio_get(&char_out);
		if (get_stat!=0)
			{
			/* Show which letter was pressed just as an example: */
			/* Directly address color_buffer: first nibble is BG, second nibble is FG*/
			color_buffer[18][15] = 0x0f;
			if (char_out > 31) // Make sure it was a printable character
				{
				disp_buffer[18][15] = char_out;
                video_gotoxy(18,18);
                video_gotoxy(1,19);
				}
			else disp_buffer[16][8] = 0xEC;
			

			wait_ms(500);	//Make sure user sees entered character
			
			/* Now do something interesting */
            dit_length = 1200/wpm;  //dit and space length in mSec per PARIS
			uint8_t code_practice = 0;
            uint16_t x = 0;
			uint8_t y = 0;
			uint32_t colorshift = 10;
            clr_buffer();
			while(1) //Loop forever
				{
                
                video_set_color(colorshift,0);
                video_gotoxy(x,y);
                stdio_write("CQ Hackaday de AI6XG");
                video_gotoxy(0,y+1);                                        //get the cursor out of the way
                wait_ms(100);
                x++;
                if (x > 20)
					{
						x = 0;
                        colorshift ++;
                      if (colorshift == 12)                                 //skip this color, not very bright
                        {
                          colorshift = 13;
                      }  
                      if (colorshift == 16)                                 //skip this color, not too bright
                        {
                          colorshift = 10;
                      }  
 
					}
                y++;
                
                
                 if (y > 19)                                                    //bottom of screen
					{
						y = 0;
                        get_stat = stdio_get(&char_out);                        //has there been a button push?
                        if (char_out=='C')                                      //CQ at bottom of screen
                            {
                            code_practice = 0;                                  //stop code practice
                            dah();dit();dah();dit();letter_space(); //C
                            dah(); dah();dit();dah();word_space();  //Q
                
                            dah();dit();dit();letter_space();   //D
                            dit();word_space();                 //E
                
                            call_sign();word_space();
                            dah();dit();dah();                  //K
                            }
                        if (char_out == 'P')
                            {
                                code_practice = 1;                              //enable code practice     
                            }
                        if (char_out == 'S')
                        {
                            code_practice = 0;                                  //stop code practice
                        }
                        if (code_practice)
                        {
                            clr_buffer();
                            uint8_t letter = 0;
                            letter = rand()%41;                                 //random number between 0 and 40
                            video_gotoxy(3,3);
                            stdio_write("What Character is this?");
                            wait_ms(750);
                            switch (letter)
                            {
                                case 0 :            //a
                                    dit();dah();
                                    letter = 'a';
                                    break;
                                case 1:             //b
                                    dah();dit();dit();dit();
                                     letter = 'b';
                                    break;
                                case 2:             //c
                                    dah();dit();dah();dit();
                                     letter = 'c';
                                    break;
                                case 3:             //d
                                    dah();dit();dit();
                                     letter = 'd';
                                    break;
                                case 4:             //e
                                    dit();
                                     letter = 'e';
                                    break;
                                case 5:             //f
                                    dit();dit();dah();dit();
                                     letter = 'f';
                                    break;
                                case 6:             //g
                                    dah();dah();dit();
                                     letter = 'g';
                                    break;
                                case 7:             //h
                                    dit();dit();dit();dit();
                                     letter = 'h';
                                    break;
                                case 8:             //i
                                    dit();dit();
                                     letter = 'i';
                                    break;
                                case 9:             //j
                                    dit();dah();dah();dah();
                                     letter = 'j';
                                    break;
                                case 10:            //k
                                    dah();dit();dah();
                                     letter = 'k';
                                    break;
                                case 11:            //l
                                    dit();dah();dit();dit();
                                     letter = 'l';
                                    break;
                                case 12 :           //m
                                    dah();dah();
                                     letter = 'm';
                                    break;
                                case 13 :           //n
                                    dah();dit();
                                     letter = 'n';
                                    break;
                                case 14:            //o
                                    dah();dah();dah();
                                     letter = 'o';
                                    break;
                                case 15 :           //p
                                    dit();dah();dah();dit();
                                     letter = 'p';
                                    break;
                                case 16 :           //q
                                    dah();dah();dit();dah();
                                     letter = 'q';
                                    break;
                                case 17 :           //r
                                    dit();dah();dit();
                                     letter = 'r';
                                    break;
                                case 18 :           //s
                                    dit();dit();dit();
                                     letter = 's';
                                    break;
                                case 19 :           //t
                                    dah();
                                     letter = 't';
                                    break;
                                case 20 :           //u
                                    dit();dit();dah();
                                     letter = 'u';
                                    break;
                                case 21 :           //v
                                    dit();dit();dit();dah();
                                     letter = 'v';
                                    break;
                                case 22 :           //w
                                    dit();dah();dah();
                                     letter = 'w';
                                    break;
                                case 23 :           //x
                                    dah();dit();dit();dah();
                                     letter = 'x';
                                    break;
                                case 24 :           //y
                                    dah();dit();dah();dah();
                                     letter = 'y';
                                    break;
                                case 25 :           //z
                                    dah();dah();dit();dit();
                                     letter = 'z';
                                    break;
                                case 26 :           //1
                                   dit();dah();dah();dah();dah();
                                   letter = '1';
                                   break;
                                case 27 :           //2
                                    dit();dit(); dah();dah();dah();
                                    letter = '2';
                                    break;
                                case 28 :           //3
                                    dit();dit();dit();dah();dah();
                                    letter = '3';
                                    break;
                                case 29 :           //4
                                    dit();dit();dit();dit();dah();
                                    letter = '4';
                                    break;
                                case 30 :           //5
                                    dit();dit();dit();dit();dit();
                                    letter = '5';
                                    break;
                                case 31 :           //6
                                    dah();dit();dit();dit();dit();
                                    letter = '6';
                                    break;
                                case 32 :           //7
                                    dah();dah();dit();dit();dit();
                                    letter = '7';
                                    break;
                                case 33 :           //8
                                    dah();dah();dah();dit();dit();
                                    letter = '8';
                                case 34 :           //9
                                    dah();dah();dah();dah();dit();
                                    letter = '9';
                                    break;
                                case 35 :           //0
                                    dah();dah();dah();dah();dah();
                                    letter = '0';
                                    break;
                                case 36 :           // .
                                    dit();dah();dit();dah();dit();dah();
                                    letter = '.';
                                    break;
                                case 37 :           //,
                                    dah();dah();dit();dit();dah();dah();
                                    letter = ',';
                                    break;
                                case 38 :           // /
                                    dah();dit();dit();dah();dit();
                                    letter = '/';
                                    break;
                                case 39 :           // -
                                    dah();dit();dit();dit();dit();dah();
                                    letter = '-';
                                    break;
                                case 40 :           // ?
                                    dit();dit();dah();dah();dit();dit();
                                    letter = '?';
                                    break;                              
                                    
                                default:
                                    break;
                            }
 
                            wait_ms(2000);                                      //time for answer
                            video_gotoxy(3,5);
                            get_stat = stdio_get(&char_out);
                            if (char_out== letter)                              //good guess
                            {
                                set_led(1,1);                                   //green LED
                                video_set_color(10,0);                          //green font
                                stdio_write("Yes, you got it right!!");
                            }
                            else                                                //bad or no guess
                            {
                                set_led(0,1);                                   //red LED
                                video_set_color(12,0);                          //red font
                                stdio_write("Wrong, totally wrong!!");
                                video_gotoxy(3,6);
                                stdio_write("The character was ");
                                color_buffer[6][24] = 0x0c;
                                disp_buffer[6][24] = letter;
                                video_gotoxy(3,32);                             //get the cursor out of the way
  
                            }
                            wait_ms(1000);                                      //time for show of glory or dispare
                            set_led(0,0);
                            set_led(1,0);
                            video_set_color(colorshift,0);                      //back to previous color
                        }
                        clr_buffer();
                        
                        
					}
                 
                

				}
			//Badge will need to be reset to continue
		}
    }
}